/*****************
Propiedad intelectual de NmadeSoft SRL (info@nomadesoft.com.ar)
---
autor: D. Abdala (dabdala@nomadesoft.com.ar)
ltima modificacin: 2010-06-01
---
Limpia el modelo de datos UML, quitando todas las tablas que no
se utilicen en ningn diagrama de unidad funcional. Accede
directamente al repositorio UML.
- ENGLISH -
Cleans the UML data model, removing all tables not referenced in
any functional unit diagram. Requires direct access to Repository
database.
*****************/
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING com.nomadesoft.ABLaUML.*.
USING com.nomadesoft.ABLaUML.repository.*.
USING com.nomadesoft.lib.*.
USING Progress.Lang.AppError.

CLASS com.nomadesoft.ABLaUML.DictCleaner:
  DEFINE PRIVATE VARIABLE cobUtils AS IUtils    NO-UNDO.

  DEFINE PUBLIC PROPERTY cobStereotypeMapper AS IMapper NO-UNDO
    GET.
    SET.

  METHOD PROTECTED CHARACTER DoMap(INPUT ipchStMap AS CHARACTER):
    IF VALID-OBJECT(cobStereotypeMapper) THEN
      ipchStMap = cobStereotypeMapper:MapIt(ipchStMap,FALSE).
    RETURN ipchStMap.
  END METHOD.

  CONSTRUCTOR PUBLIC DictCleaner(INPUT ipobLogger AS CLASS ILogger):
    cobUtils = NEW EAUtils(TRUE).
  END CONSTRUCTOR.

  /** destructor **/
  DESTRUCTOR DictCleaner():
    DELETE OBJECT cobUtils.
  END DESTRUCTOR.

  /* busca todos los objetos (tablas) del modelo de datos que no estn relacionados a otros objetos y los elimina */
  METHOD PUBLIC VOID CleanIt():
    define buffer mbfObject for Repository.t_Object.
    DEFINE VARIABLE mchStereotype AS CHARACTER   NO-UNDO.

    mchStereotype = DoMap('nsTable').
    FOR EACH mbfObject WHERE mbfObject.Object_Type EQ 'Class' AND mbfObject.Stereotype EQ mchStereotype:
      IF cobUtils:DataLinkCount(mbfObject.OBJECT_ID) EQ 0 THEN
        DELETE mbfObject.
    END.
  END METHOD.
END CLASS.
