/*****************
Propiedad intelectual de NmadeSoft SRL (info@nomadesoft.com.ar)
---
autor: D. Abdala (dabdala@nomadesoft.com.ar)
ltima modificacin: 2010-06-01
---
Interfaz para el procesamiento de un XML, es utilizada por el encapsulamiento
SAX que permite a una clase utilizar un SAXreader.
Tambin determina los mtodos necesarios para las clases constructoras del
modelo, las cuales utilizan un IXMLParser para "alimentarse".
- ENGLISH -
Interface for XML processing, is used by SAX wrapping, allowing a class to use
a SAXreader.
It also defines the signatures to be used by worker classes, which uses an
IXMLParser to obtain data.
*****************/
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING com.nomadesoft.lib.IXMLWorker.

/* interfaz que deben implementar quienes hacen el trabajo real en base al xml que se est procesando */
INTERFACE com.nomadesoft.lib.IXMLParser:
  /* utilizado por SAX */
  METHOD PUBLIC LOGICAL DocumentStart().
  METHOD PUBLIC LOGICAL DocumentEnd().
  METHOD PUBLIC LOGICAL ElementStart(INPUT ipchNamespaceURI AS CHARACTER, INPUT ipchLocalName AS CHARACTER, INPUT ipchQualifiedName AS CHARACTER, INPUT ipchSAXAttObj AS HANDLE).
  METHOD PUBLIC LOGICAL ElementEnd(INPUT ipchNamespaceURI AS CHARACTER, INPUT ipchLocalName AS CHARACTER, INPUT ipchQualifiedName AS CHARACTER).
  METHOD PUBLIC LOGICAL Content(INPUT ipchContent AS CHARACTER).
  METHOD PUBLIC VOID XMLError(INPUT ipchMessage AS CHARACTER).
  /* utilizado por los worker */
  METHOD PUBLIC CHARACTER AttributeValue(INPUT ipchAttName AS CHARACTER).
  METHOD PUBLIC CHARACTER CurrentElement().
  METHOD PUBLIC CHARACTER ParentElement(INPUT ipinLevel AS INTEGER).
  METHOD PUBLIC LOGICAL AttributeExists(INPUT ipchAttName AS CHARACTER).
  METHOD PUBLIC CHARACTER ElementContent().
  METHOD PUBLIC VOID DoLog(INPUT ipchSource AS CHARACTER, INPUT ipchData AS CHARACTER, INPUT ipchLevel AS CHARACTER).
  /* manejo externo */
  METHOD PUBLIC IXMLWorker SetWorker(INPUT ipobNewWorker AS IXMLWorker). /* interfaz fluda debe devolver el parmetro recibido */
  METHOD PUBLIC VOID Parse(INPUT iphnStream AS HANDLE).
  METHOD PUBLIC VOID Parse(INPUT ipchFile AS CHARACTER).
END INTERFACE.
