/*****************
Propiedad intelectual de NmadeSoft SRL (info@nomadesoft.com.ar)
Tomado de la infraestructura comn NSRA.
---
autor: D. Abdala (dabdala@nomadesoft.com.ar)
ltima modificacin: 2010-06-01
---
Procedimientos utilizados por SAX para procesar un XML, invocan los
mtodos equivalentes de la clase que instancia persistentemente el
archivo. La funcin de este archivo es permitir utilizar una clase
para el procesamiento SAX.
- ENGLISH -
SAX procedures that invokes equivalent methods, of the class
that has run this file persistently. It only function is to
allow a class to use SAX.
*****************/
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING com.nomadesoft.lib.IXMLParser.

DEFINE INPUT  PARAMETER gobParser AS CLASS IXMLParser NO-UNDO.

DEFINE VARIABLE ghnSaxReader AS HANDLE NO-UNDO.

/* ***************************  Main Block  *************************** */
CREATE SAX-READER ghnSaxReader.

PROCEDURE Parse:
  DEFINE INPUT  PARAMETER ipchArchivo AS CHARACTER   NO-UNDO.
  DEFINE INPUT  PARAMETER iphnWebContext AS HANDLE      NO-UNDO.
 
  /* setea origen de datos de paquete xml de acuerdo a tipo */
  IF iphnWebContext EQ ? THEN
    ghnSaxReader:SET-INPUT-SOURCE('FILE', ipchArchivo).
  ELSE
    ghnSaxReader:SET-INPUT-SOURCE('HANDLE', iphnWebContext).
  ghnSaxReader:SAX-PARSE() NO-ERROR.
  IF ERROR-STATUS:ERROR THEN
    UNDO, THROW NEW Progress.Lang.AppError(ERROR-STATUS:GET-MESSAGE(1),ERROR-STATUS:GET-NUMBER(1)).
END PROCEDURE.  

/*-[pi]-----------------------------------------------------------------------*/
/* parseo xml - invocado al inicio de la lectura                              */
/*----------------------------------------------------------------------------*/
PROCEDURE StartDocument:
  IF NOT gobParser:DocumentStart() THEN
    RETURN ERROR.
END PROCEDURE.

/*-[pi]-----------------------------------------------------------------------*/
/* parseo xml - invocado en cada inicio de elemento                           */
/*----------------------------------------------------------------------------*/
PROCEDURE StartElement:
  DEFINE INPUT  PARAMETER ipchNameSpaceURI AS CHARACTER   NO-UNDO.
  DEFINE INPUT  PARAMETER ipchLocalName AS CHARACTER   NO-UNDO.
  DEFINE INPUT  PARAMETER ipchQName AS CHARACTER   NO-UNDO.
  DEFINE INPUT  PARAMETER iphnSaxAttObj AS HANDLE      NO-UNDO.

  IF NOT gobParser:ElementStart(ipchNameSpaceURI,ipchLocalName,ipchQName,iphnSaxAttObj) THEN
    RETURN ERROR.
END PROCEDURE.

/*----------------------------------------------------------------------------*/
/*[pi] parseo xml - invocado en cada instancia de datos cdata                 */
/*----------------------------------------------------------------------------*/
PROCEDURE Characters:
  DEFINE INPUT  PARAMETER ipmpData AS MEMPTR      NO-UNDO.
  DEFINE INPUT  PARAMETER ipinCount AS INTEGER     NO-UNDO.

  IF NOT gobParser:Content(GET-STRING(ipmpData,1,ipinCount)) THEN
    RETURN ERROR.
END PROCEDURE.

/*-[pi]-----------------------------------------------------------------------*/
/* parseo xml - invocado en cada cierre de elemento                           */
/*----------------------------------------------------------------------------*/
PROCEDURE EndElement:
  DEFINE INPUT  PARAMETER ipchNameSpaceURI AS CHARACTER   NO-UNDO.
  DEFINE INPUT  PARAMETER ipchLocalName AS CHARACTER   NO-UNDO.
  DEFINE INPUT  PARAMETER ipchQName AS CHARACTER   NO-UNDO.

  IF NOT gobParser:ElementEnd(ipchNameSpaceURI,ipchLocalName,ipchQName) THEN
    RETURN ERROR.
END PROCEDURE.

/*-[pi]-----------------------------------------------------------------------*/
/* parseo xml - invocado en caso de error comun                               */
/*----------------------------------------------------------------------------*/
PROCEDURE Error:
  DEFINE INPUT  PARAMETER ipchMessage AS CHARACTER   NO-UNDO.
  gobParser:XMLError(ipchMessage).
  RETURN ERROR.
END PROCEDURE.

/*-[pi]-----------------------------------------------------------------------*/
/* parseo xml - invocado en caso de error fatal                               */
/*----------------------------------------------------------------------------*/
PROCEDURE FatalError:
  DEFINE INPUT  PARAMETER ipchMessage AS CHARACTER   NO-UNDO.
  gobParser:XMLError(ipchMessage).
  RETURN ERROR.
END PROCEDURE.

/*-[pi]-----------------------------------------------------------------------*/
/* parseo xml - invocado al final de la lectura                               */
/*----------------------------------------------------------------------------*/
PROCEDURE EndDocument:
  IF NOT gobParser:DocumentEnd() THEN
    RETURN ERROR.
END PROCEDURE.
